/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef ZXMENU_H
#define ZXMENU_H

#include <PA9.h>   
#include <string>

#include "cancel.h"
#include "left.h"
#include "nosound.h"
#include "right.h"
#include "save.h"
#include "sound.h"
#include "notools.h"
#include "screenshot.h"
#include "tools.h"

#define I_CANCEL_X 4
#define I_CANCEL_Y 4
#define I_SCREENSHOT_X 159
#define I_SCREENSHOT_Y 4
#define I_SAVE_X 183
#define I_SAVE_Y 4
#define I_TOOLS_X 207
#define I_TOOLS_Y 4
#define I_SOUND_X 231
#define I_SOUND_Y 4

#define I_LEFT_X 4
#define I_LEFT_Y 85
#define I_RIGHT_X 231
#define I_RIGHT_Y 85

#define I_W 21
#define I_H 21

#include "ZXCfg.h"
#include <list>
#include <string>
class ZXFiles;
class ZXULA;

#define FIND_MAX_DEPTH 5

class ZXMenu {
 public:
  ZXMenu (ZXULA *aZXULA);
  ~ZXMenu ();
  void hide();
  void show();
  int process (std::string &name, std::deque<std::string> & sequence);

 private:
  int isStylusArea (u8 x, u8 y, u8 w, u8 h);
  void drawGifFromSna (u8 screen, const std::string &file);
  void showSequence (const std::deque<std::string> &seq) const;
  bool findFile (const std::string &f, std::string rep);

  ZXFiles *_files;
  ZXCfg *_config;
  ZXULA *theZXULA;
  std::string _rootdir;
  std::list<std::string>::iterator _it_sna;
  int _find_depth;
};

#endif
